<template>
    <div class="search-form">
        <div class="row">
            <div class="col-md-2">
                <div class="form-group">
                    <label for="product-type">Product Type</label>
                    <select id="product-type" class="form-control" v-model="productType" v-on:change="typeChanged">
                        <option value="1">Product</option>
                        <option value="2">Product Set</option>
                    </select>
                </div>
            </div>
            <div class="col-md-10">
                <div class="form-group auto-complete-search">
                    <label for="product-id">Search Item</label>
                    <input type="text" class="form-control" v-on:blur="onBlur"  v-on:focus="onFocus" v-model="formText" v-on:keyup="onFocus">
                    <ul v-if="showList" class="searched-item-list">
                        <li v-for="(item,index) in items" v-on:click="pushToPurchase(index)">{{ item.name }}</li>
                    </ul>
                </div>
            </div>
        </div>

        <div class="row">
            <div class="col-md-12">
                <table class="table table-bordered list-table">
                    <thead>
                    <tr>
                        <th>Item Name</th>
                        <th>Item Type</th>
                        <th>Unit</th>
                        <th class="w-100">Price</th>
                        <th class="w-100">Quantity</th>
                        <th>Sub Total</th>
                        <th></th>
                    </tr>
                    </thead>
                    <tbody>
                    <tr v-for="(purchaseItem,index) in purchaseItemsList">
                        <td>{{ purchaseItem.name }} <input type="hidden" :name="'product['+ index +'][id]'" :value="purchaseItem.id"> </td>
                        <td>{{ purchaseItem.type == 1 ? 'Product' : 'Product Set' }} <input type="hidden" :name="'product['+ index +'][type]'" :value="purchaseItem.type"></td>
                        <td>{{ purchaseItem.unit }}</td>
                        <td><input type="number" class="form-control none-border-input" :name="'product['+ index +'][price]'" v-model="purchaseItemsList[index].price" v-on:keyup="changePrice(index)" required> </td>
                        <td><input type="number" class="form-control none-border-input" :name="'product['+ index +'][quantity]'" v-model="purchaseItemsList[index].quantity" v-on:keyup="changeQuantity(index)" min="1" required> </td>
                        <td>{{ purchaseItemsList[index].subTotal }}</td>
                        <td><button class="btn-remove" type="button" @click="popFromPurchase(index)">-</button></td>
                    </tr>
                    <tr v-if="purchaseItemsList.length">
                        <td colspan="5">Grand Total</td>
                        <td>{{ purchaseTotal}}</td>
                        <td></td>
                    </tr>
                    </tbody>
                </table>
            </div>
        </div>

    </div>
</template>

<script>
    export default {

        data: function () {
            return {
                showList: false,
                productType: 1,
                formText: "",
                items: [],
                purchaseItemsList:[],
                purchaseTotal: 0,
                products: [],
                productSets: [],
            };
        },

        methods: {
            initItems: function(){
                var app = this;
                axios.get('/get-product-and-product-sets/')
                    .then(response => {
                        app.products = response.data.product;
                        app.productSets = response.data.sets;
                        console.log(resp.data);

                    })
                    .catch(e => {
                        this.errors.push(e)
                    });
            },
            typeChanged: function(){
                this.items = [];
                this.formText = "";
            },
            onBlur: function(){
                let app = this;
                setTimeout(function () {
                    app.showList = false;
                },1000)
            },
            onFocus: function(){

                this.showList = true;

                if(this.productType == 1){
                    if(this.formText.length){
                        this.items = this.products.filter((item) => {
                            return item.name.toUpperCase().search(this.formText.toUpperCase()) != -1;
                        });
                    }else{
                        this.items = this.products;
                    }
                    console.log(this.products);
                }else{
                    if(this.formText.length){
                        this.items = this.productSets.filter((item) => {
                            return item.name.toUpperCase().search(this.formText.toUpperCase()) != -1;
                        });
                    }else{
                        this.items = this.productSets;
                    }
                }
            },
            pushToPurchase: function (index) {

                this.showList = false;

                let item = this.items[index];
                this.items.splice(index,1);

                if(item.type == 1){
                    this.removeProduct(item.id);
                }else{
                    this.removeProductSet(item.id);
                }
                //item.quantity = 1;
                //item.subTotal = item.price;

                this.purchaseItemsList.push(item)

                this.calculateTotal();
            },
            popFromPurchase: function (index) {
                let item = this.purchaseItemsList[index];
                this.purchaseItemsList.splice(index,1);

                //delete item.quantity;
                //delete item.subTotal;

                if(item.type == 1){
                    this.products.push(item);
                }else{
                    this.productSets.push(item)
                }

                this.calculateTotal();
            },
            removeProduct: function (id) {
                for (let i=0; i<this.products.length; i++){
                    if(this.products[i].id == id){
                        this.products.splice(i,1);
                        break;
                    }
                }
            },
            removeProductSet: function (id) {
                for (let i=0; i<this.productSets.length; i++){
                    if(this.productSets[i].id == id){
                        this.productSets.splice(i,1);
                        break;
                    }
                }
            },
            calculateTotal: function () {
                this.purchaseTotal = 0.0;
                for (let i=0; i<this.purchaseItemsList.length; i++){
                    this.purchaseTotal += this.purchaseItemsList[i].price * this.purchaseItemsList[i].quantity;
                }

                this.purchaseTotal.toFixed(2);
            },
            changeQuantity: function (index) {
                let item = this.purchaseItemsList[index];
                let st = parseFloat(item.quantity) * parseFloat(item.price);
                item.subTotal = st.toFixed(2);
                this.purchaseItemsList.splice(index,1,item);
                this.calculateTotal();
            },
            changePrice: function (index) {
                let item = this.purchaseItemsList[index];
                let st = parseFloat(item.quantity) * parseFloat(item.price);
                item.subTotal = st.toFixed(2);
                this.purchaseItemsList.splice(index,1,item);
                this.calculateTotal();
            },
        },
        created: function() {
            this.initItems();
        },
        mounted() {
            console.log('Component mounted.')
        }
    }
</script>
